︠513a47f2-9969-4422-9add-42d42f2e0b96i︠
%md
We create the number field $K = \QQ[\zeta_3,i]$ and the unique $3$-adic valuation $v_K$ on $K$. We normalize $v_K$ such that $v_K(\pi_K)=1$.

︡f64db820-2eef-4961-a6a9-ba027a145f8f︡{"done":true,"md":"We create the number field $K = \\QQ[\\zeta_3,i]$ and the unique $3$-adic valuation $v_K$ on $K$. We normalize $v_K$ such that $v_K(\\pi_K)=1$."}
︠61840497-66b3-4933-a5cc-494a4584f76cs︠
K.<zeta,ii> = NumberField([x^2+x+1,x^2+1])
v_3 = QQ.valuation(3)
vK = 2*v_3.extension(K)  # vK is normalized
piK = vK.uniformizer()
piK
vK(piK)
︡9de2ed17-73e3-4ceb-8809-880da80cb006︡{"stdout":"zeta + 2\n"}︡{"stdout":"1\n"}︡{"done":true}︡
︠9daeba5b-ccec-4e00-a80d-56e725a4f4adi︠
%md
We create the extension $M_1/K$ by adjoining a $3$rd root of $4=1+3$ and the unique extension $v_{M_1}$ of $v_K$. 
︡b01a1fcf-d066-4f36-995f-aa0fe4dca9c6︡{"done":true,"md":"We create the extension $M_1/K$ by adjoining a $3$rd root of $4=1+3$ and the unique extension $v_{M_1}$ of $v_K$."}
︠8cc702a4-341e-45f9-8a11-48a3b5e3f9dds︠
R.<x> = K[]
M1.<alpha> = K.extension(x^3-4)
vM1 = vK.extension(M1)
piM1 = vM1.uniformizer()
vM1(piM1)
︡fc09bc54-27e9-4c3b-9720-6c3c141e44d0︡{"stdout":"1/3\n"}︡{"done":true}︡
︠426155ea-cf32-47a5-92b1-fe3d6b262bf8i︠
%md
We check that $M_1/K$ has ramification jump $1$, which means that $v_{M_1}(\pi_{M_1}-\sigma(\pi_{M_1}))=2/3$.
︡8dbca33f-b33e-4130-9d35-07f17585fc16︡{"done":true,"md":"We check that $M_1/K$ has ramification jump $1$, which means that $v_{M_1}(\\pi_{M_1}-\\sigma(\\pi_{M_1}))=2/3$."}
︠889d9db4-ab55-4abd-8892-2e1b230f58c7s︠
roots = piM1.minpoly().roots(M1,multiplicities=False)
vM1(roots[0]-roots[1])
vM1(roots[0]-roots[2])
vM1(roots[1]-roots[2])
︡f47573de-cf9c-40f0-a820-1e1b2856bf20︡{"stdout":"2/3\n"}︡{"stdout":"2/3\n"}︡{"stdout":"2/3\n"}︡{"done":true}︡
︠e199b1e2-b634-409e-804d-3a5a380f7a83i︠
%md
We create the extension $M/K$ by adjoining a $3$rd root of $1+\pi_K$ and the unique extension $v_M$ of $v_K$. 

We check that $M/K$ has ramification jump $2$, which means that $v_M(\pi_M-\tau(\pi_M))=1$.
︡7bc7969d-270e-4b04-9725-b4deb4b1cb58︡{"done":true,"md":"We create the extension $M/K$ by adjoining a $3$rd root of $1+\\pi_K$ and the unique extension $v_M$ of $v_K$. \n\nWe check that $M/K$ has ramification jump $2$, which means that $v_M(\\pi_M-\\tau(\\pi_M))=1$."}
︠03733272-24d0-4ec4-b96c-8b33b436832fs︠
f = x^3-(1+piK)
M.<alpha1> = K.extension(f)
vM = vK.extension(M)
piM = vM.uniformizer()
vM(piM)
︡86bab7ec-9b25-4f76-ba17-a32838c10a40︡{"stdout":"1/3\n"}︡{"done":true}︡
︠dbd1893d-3e90-48f7-a58b-deb7275853d6s︠
roots = piM.minpoly().roots(M,multiplicities=False)
vM(roots[0]-roots[1])
vM(roots[0]-roots[2])
vM(roots[1]-roots[2])
︡f195ac7f-0a37-4b2c-bfee-72c198dfd04a︡{"stdout":"1\n"}︡{"stdout":"1\n"}︡{"stdout":"1\n"}︡{"done":true}︡
︠856cbd2a-2413-4746-a5e8-512962a555c1i︠
%md
We create the extension $L=MM_1/M$ and the unique extension $v_L$ of $v_M$. 
︡0ac7dda5-9463-4e01-80a7-081db5f99302︡{"done":true,"md":"We create the extension $L=MM_1/M$ and the unique extension $v_L$ of $v_M$."}
︠403e03af-6933-4680-a7c7-db2efd9d7027s︠
L.<beta> = M.extension(x^3-4)
vL = vM.extension(L)
piL = vL.uniformizer()
vL(piL)
︡dafc7d25-7fd1-4cf8-8dc9-1b96e9d39c9a︡{"stdout":"1/9\n"}︡{"done":true}︡
︠1c47274c-bc5b-4e07-beb8-1ebf89173747i︠
%md
We check that the extension $L/M$ has ramification jump $1$, which means that $v_L(\sigma(\pi_L)-\pi_L)=2/9$.
︡5c086456-51f9-4fca-bdd2-bc472203f2ce︡{"done":true,"md":"We check that the extension $L/M$ has ramification jump $1$, which means that $v_L(\\sigma(\\pi_L)-\\pi_L)=2/9$."}
︠7d207890-afff-4ef8-a0db-a239c98cd8b5s︠
from sage.geometry.newton_polygon import NewtonPolygon
F = piL.minpoly()(x+piL)
NP = NewtonPolygon([(i,vL(F[i])) for i in range(4)])
NP.slopes(False)
NP.vertices()
︡bac0f380-6663-428a-9ece-aaed79549e96︡{"stdout":"[-2/9]\n"}︡{"stdout":"[(1, 4/9), (3, 0)]\n"}︡{"done":true}︡
︠9674b82d-82c0-4c5c-98e0-8cf504a5ab46i︠
%md
We check that the extension $L/K$ has ramification jumps $1$ and $4$. This means that (in addition to the calculation in the previous cell) $v_L(\tau(\pi_L)-\pi_L) = 5/9$. To check this, we compute the Newton polygon of $f(x+\pi_L)$, where $f$ is the minimal polynomial of $\pi_L$ over $K$. 
︡ce59f277-c1fc-4f85-bcbe-90ce80ae6a91︡{"done":true,"md":"We check that the extension $L/K$ has ramification jumps $1$ and $4$. This means that (in addition to the calculation in the previous cell) $v_L(\\tau(\\pi_L)-\\pi_L) = 5/9$. To check this, we compute the Newton polygon of $f(x+\\pi_L)$, where $f$ is the minimal polynomial of $\\pi_L$ over $K$."}
︠2269f891-5646-4287-879c-f3fa9d9256ebs︠
f = piL.absolute_minpoly().change_ring(K).factor()[1][0] # compute the *absolute* minimal polynomial and factor it over K. Choose one  factor.
f(piL)  # check that f is the correct factor 
F = f(x+piL)
NP = NewtonPolygon([(i,vL(F[i])) for i in range(10)])
NP.slopes(False)
︡a3bc350b-98b3-4194-b532-6aaa5cd5b2b9︡{"stdout":"0\n"}︡{"stdout":"[-5/9, -2/9]\n"}︡{"done":true}︡
︠4902d387-1fb1-431f-b7f7-fc7026c0f4b5i︠
%md
We define the element $\xi= \pi_M+i\cdot\pi_M^2\pi_L^2\in L$. It has valuation $v_L(\xi)=1/3$.
︡7d33dff6-ac35-401f-a6d0-59761683fd67︡{"done":true,"md":"We define the element $\\xi= \\pi_M+i\\cdot\\pi_M^2\\pi_L^2\\in L$. It has valuation $v_L(\\xi)=1/3$."}
︠45cf573f-de4f-4b6b-8c7e-2e86fc29deb7s︠
xi = piM+ii*piM^2*piL^2
vL(xi)
︡47bdf8ea-b173-4561-8926-63804d8c8cd9︡{"stdout":"1/3"}︡{"stdout":"\n"}︡{"done":true}︡
︠8d457c0c-553f-4601-a8db-4b9d2795fc1fi︠
%md
We compute the minimal polynomial $h$ of $\xi$ over $K$.
︡1dcd2ad3-eca1-4d6c-9358-a920b1fda319︡{"done":true,"md":"We compute the minimal polynomial $h$ of $\\xi$ over $K$."}
︠9261d9f8-2891-4f80-a554-f361b59aab10s︠
h = xi.absolute_minpoly().change_ring(K).factor()[0][0]
h(xi) # check that h is the correct factor
︡4a932d59-b63a-4b42-958f-504f1c199fdd︡{"stdout":"0\n"}︡{"done":true}︡
︠689e91fe-1175-48e8-b1a0-d8c64ee68d2ai︠
%md
We compute the slopes of the Newton polygon of $h(\xi+x)$, which should give the two values  $v_L(\sigma(\xi)-\xi)$ and $v_L(\tau(\xi)-\xi)$.
︡02b99ef0-7b70-4800-a6d2-9ee5aa02d1ff︡{"done":true,"md":"We compute the slopes of the Newton polygon of $h(\\xi+x)$, which should give the two values  $v_L(\\sigma(\\xi)-\\xi)$ and $v_L(\\tau(\\xi)-\\xi)$."}
︠9abc843d-1232-41e4-929e-9f3afe4fa677s︠
F = h(x+xi)
NP = NewtonPolygon([(i,vL(F[i])) for i in range(10)])
NP.slopes(False)
NP.vertices()
︡004fc1be-7fdf-44b8-8f49-3770538a39ad︡{"stdout":"[-1]\n"}︡{"stdout":"[(1, 8), (9, 0)]\n"}︡{"done":true}︡
︠de69e6f9-bd00-4df8-9152-1202dbc84d12s︠
roots = h.roots(L,multiplicities=False)
len(roots)
[vL(roots[0]-roots[i]) for i in range(9)]
︡a84f42ea-7c07-42e6-9767-d8a792356a66︡{"stdout":"9\n"}︡{"stdout":"[+Infinity, 1, 1, 1, 1, 1, 1, 1, 1]"}︡{"stdout":"\n"}︡{"done":true}︡
︠a46598ea-0077-4f08-a97f-8f2066179583︠

︡964bbad4-6711-4a45-b96a-7241c668c112︡
︠5b2f1ecb-0f08-4ad7-a911-e55505caeb38i︠
%md
So, indeed, the roots of $h$ are equidistant. We now find the inductive description of the valuation $v$ corresponding to the smallest closed discoid containing all the roots of $h$. In particular, $v(h)=9$.
︡43d68e89-c76a-462c-a540-27795707d970︡{"done":true,"md":"So, indeed, the roots of $h$ are equidistant. We now find the inductive description of the valuation $v$ corresponding to the smallest closed discoid containing all the roots of $h$. In particular, $v(h)=9$."}
︠58ce2fd3-143b-4b19-9574-d8cc301b4987︠
︡efe32267-ea7c-46f3-83ef-ca6981ce9c72︡
︠da4c4be6-8cda-42cd-8156-4fb70e8c24bfs︠
v_2 = vK.mac_lane_approximants(h)[0]
v_2
︡5623d1e0-1ef3-41f8-9211-5a804ae10701︡{"stdout":"[ Gauss valuation induced by 2 * 3-adic valuation, v(x) = 1/3, v(x^3 + ((3*ii + 6)*zeta + 3*ii + 6)*x^2 + (6*zeta + 6)*x + 2*zeta + 4) = 26/9 ]\n"}︡{"done":true}︡
︠8ae51ef2-6b2c-42be-9904-aa0b19787b46s︠
v = v_2.augmentation(h, 9)
v
︡b95998a3-6145-4cd4-a284-7935bfe58955︡{"stdout":"[ Gauss valuation induced by 2 * 3-adic valuation, v(x) = 1/3, v(x^3 + ((3*ii + 6)*zeta + 3*ii + 6)*x^2 + (6*zeta + 6)*x + 2*zeta + 4) = 26/9, v(x^9 + (74602670811792/3512479453921*ii*zeta + 146986584778983/3512479453921*ii - 18)*x^8 + ((-1222485266930784/3512479453921*ii - 4008186705411751344596199936/12337511914217166362274241)*zeta - 2557856643579120/3512479453921*ii - 964597146359375724085346292/12337511914217166362274241)*x^7 + ((-21583298674312903018973205448573812418944/43335257111193343900365036083324748961*ii + 71719289159882035280184405789/12337511914217166362274241)*zeta + 273824864118563533833252260482968200143572/43335257111193343900365036083324748961*ii + 43049777314608595284840071247/12337511914217166362274241)*x^6 + ((1705352989934099596738405413442366201406418/43335257111193343900365036083324748961*ii - 1225968286958867252774624274003320181932508/43335257111193343900365036083324748961)*zeta - 1196505810197375269482325978716962855898810/43335257111193343900365036083324748961*ii - 1147153372683541514766635380728115120032006/43335257111193343900365036083324748961)*x^5 + ((-11928490296651303171673786573971897643001940/43335257111193343900365036083324748961*ii - 1854761985118034365823143199659123546079367/43335257111193343900365036083324748961)*zeta + 2491733677171895696235393815215943774812230/43335257111193343900365036083324748961*ii + 2664337064789362976442801515047708464278175/43335257111193343900365036083324748961)*x^4 + ((32040266800632365447338743594500379468557076/43335257111193343900365036083324748961*ii + 34980109525673272202253315061246446899535975/43335257111193343900365036083324748961)*zeta - 4369276508883843456080979560040077865194292/43335257111193343900365036083324748961*ii + 7383399832555383620416670802245096344860732/43335257111193343900365036083324748961)*x^3 + ((-22478848747486807782641038124155003319901957/43335257111193343900365036083324748961*ii - 113589465707005692375468274592162219742579903/43335257111193343900365036083324748961)*zeta + 18378184432679757733572537139534812833805732/43335257111193343900365036083324748961*ii - 52436384011971244056800117557923480424365255/43335257111193343900365036083324748961)*x^2 + ((-40222932846171372341535168224480352480220458/43335257111193343900365036083324748961*ii + 135812887152645474910221339921134204672546427/43335257111193343900365036083324748961)*zeta - 47375643405570773544668000986580882342882826/43335257111193343900365036083324748961*ii + 99445203029101904779168036802713697007629517/43335257111193343900365036083324748961)*x + (52565441391170988315281193378144505924561815/43335257111193343900365036083324748961*ii - 33972292363890387895228582376360723971923921/43335257111193343900365036083324748961)*zeta + 41243915434968400554917375560900055419255659/43335257111193343900365036083324748961*ii - 61479708860330861057788774767469482819700920/43335257111193343900365036083324748961) = 9 ]\n"}︡{"done":true}︡
︠5935e95b-1d75-435d-a2c5-2da37b418d53i︠
%md
As expected, $v$ is of the form $v=[v_0,v_1(x)=1/3, v_2(phi_2)=26/9, v(h)=9]$.

We check that the minimal polynomial of $\pi_M$ cannot take the role of $\phi_2$.
︡8b777a3a-a827-4b3e-8055-39af30af2907︡{"done":true,"md":"As expected, $v$ is of the form $v=[v_0,v_1(x)=1/3, v_2(phi_2)=26/9, v(h)=9]$.\n\nWe check that the minimal polynomial of $\\pi_M$ cannot take the role of $\\phi_2$."}
︠f9260cf6-d8b0-4c61-80cd-522d372bdadfs︠
g = piM.minpoly()
g
v(g)
︡3349d416-36df-432f-b831-690f73686d21︡{"stdout":"x^3 - 6*x^2 + 12*x - zeta - 11\n"}︡{"stdout":"8/3\n"}︡{"done":true}︡
︠ccd7673e-97d2-44ee-96c3-044eec3161f0s︠
g = v_2.phi()
g
v(g)
︡9cdf358a-4cef-44c7-8e8b-9d358202425b︡{"stdout":"x^3 + ((3*ii + 6)*zeta + 3*ii + 6)*x^2 + (6*zeta + 6)*x + 2*zeta + 4\n"}︡{"stdout":"26/9\n"}︡{"done":true}︡
︠b7aba563-7d40-495b-804f-fd483f220210s︠
G = g(x+xi)
NP = NewtonPolygon([(i,vL(G[i])) for i in range(4)])
NP.slopes(False)
NP.vertices()
︡1fef4b1b-c706-4dc0-aeee-3ca61888b5f0︡{"stdout":"[-26/27]\n"}︡{"stdout":"[(0, 26/9), (3, 0)]\n"}︡{"done":true}︡
︠b9e1a05d-d85d-473f-a15a-fa191eb99c27︠









